# -*- coding: utf-8 -*-
"""
Created on Sat Jun 02 17:23:52 2012

@author: Zubin
"""

import numpy as np
import glob
import matplotlib.pyplot as plt
from matplotlib.pyplot import *
import scipy

def Readfile(XVGFile):
    Yarray2=[]
    count=0
    for line in file(XVGFile,'r').readlines():
        if line.startswith("#") or line.startswith("@"):
#            print line
            continue
        else:
            
            count=count+1
            line=line.strip()
            sline=line.split()
            Yarray2.append(sline[2])
            TotalColumn.append(sline[2])
            if (count==1):
                z0=sline[2]
    Yarray=np.array(Yarray2,float)
#    print count
    return  Yarray,Yarray2,TotalColumn,z0
    
    
def WHAM(TotalCounts,TotalBins, z0array, n, J, Atol,maxiter):    
    logn= np.log(n)
#    print logn
    beta=1.666
    Aold=np.zeros(J,dtype=float)
#    Aold=np.array([1.00,2.00,2.00,2.00,2.00,2.00,2.00,2.00,2.00])
    sumFz=np.zeros(J,dtype=float)
#    print Aold
    betaF=np.zeros(len(TotalBins),dtype=float)
    negbetaF=np.zeros(len(TotalBins),dtype=float)
    sumj=np.zeros(len(TotalBins),dtype=float)
    betaAold=beta*Aold 
    betaAnew=np.zeros(J,dtype=float)
    factor1=np.zeros(J,dtype=float)
    factor2=np.zeros(J,dtype=float)
    factor3=np.zeros(len(TotalBins),dtype=float)
    factor4=np.zeros(len(TotalBins),dtype=float)
#    print TotalBins
    
    
    for z in range(len(TotalBins)):
           
          sumj[z]=0
              
          for j in range(J):
            factor1[j]=-(2500.0*beta)/(2.0*4.184)*(TotalBins[z]-z0array[j])**2
            print factor1[j]
            factor2[j]=factor1[j]+betaAold[j]
            print factor2[j]
          f2max=max(factor2)
          for j in range(J):
              sumj[z]=sumj[z]+np.exp(factor2[j]-f2max)
                    
          if (TotalCounts[z]==0):
              continue
          else:
              betaF[z]=np.log(TotalCounts[z])-logn-np.log(sumj[z])-(f2max)
              negbetaF[z]=-1*betaF[z]
#          print TotalCounts[z]
#       print betaF
       
         
       
    for j in range(J):
          sumFz[j]=0
#          print j
          for z in range(len(betaF)):
            factor3[z]=-(2500.0*beta)/(2.0*4.184) *(TotalBins[z]-z0array[j])**2
            factor4[z]=factor3[z]-betaF[z]
#            print  factor3[z],"\t",factor4[z]
          f4max=max(factor4)
#          print f4max
          for z in range(len(betaF)):  
            sumFz[j]=sumFz[j]+np.exp(factor4[z]-f4max)
#            print sumFz[j]
            
          betaAnew[j]=-1*np.log(sumFz[j])-(f4max)

    
    iteration =0
    
    betaAold=betaAnew
    
    
#    print betaAold
#    print betaAnew    
    delta=99.0
    while (delta > Atol) & (iteration < maxiter) :    
       print betaAold
       for z in range(len(TotalBins)):
           
          sumj[z]=0
              
          for j in range(J):
            factor1[j]=-(2500.0*beta)/(2.0*4.184)*(TotalBins[z]-z0array[j])**2
#            print factor1[j]
            factor2[j]=factor1[j]+betaAold[j]
#            print factor2[j]
          f2max=max(factor2)
          for j in range(J):
              sumj[z]=sumj[z]+np.exp(factor2[j]-f2max)
                    
          if (TotalCounts[z]==0):
              continue
          else:
              betaF[z]=np.log(TotalCounts[z])-logn-np.log(sumj[z])-(f2max)
              negbetaF[z]=-1*betaF[z]
#          print TotalCounts[z]
#       print betaF
       
         
       
       for j in range(J):
          sumFz[j]=0
#          print j
          for z in range(len(betaF)):
            factor3[z]=-(2500.0*beta)/(2.0*4.184) *(TotalBins[z]-z0array[j])**2
            factor4[z]=factor3[z]-betaF[z]
#            print  factor3[z],"\t",factor4[z]
          f4max=max(factor4)
#          print f4max
          for z in range(len(betaF)):  
            sumFz[j]=sumFz[j]+np.exp(factor4[z]-f4max)
#            print sumFz[j]
            
          betaAnew[j]=-1*np.log(sumFz[j])-(f4max)
          
#       print betaAold
#       print betaAnew
       betaAnew=betaAnew-betaAnew.min()
       iteration=iteration+1
       print iteration
       
       
       delta=np.linalg.norm((betaAold-betaAnew),1)/np.linalg.norm((betaAnew),1)
       
       delta3=np.max(abs((betaAold-betaAnew)))
       print delta
#       print delta3
       betaAold=betaAnew
       
    A=betaAnew/beta
    print A, negbetaF
    return A, betaF,negbetaF
       
    

#Modele Level code
k=2500

XVGFileset = glob.glob("*.xvg")
J=len(XVGFileset)
print J
Yarray2=np.zeros(J,float)
z0list=[]
TotalColumn=[]

for (j, XVGFile) in enumerate(XVGFileset):
#    print XVGFile, j
    Yarray,Yarray2,TotalColumn,z0 = Readfile(XVGFile)
#    print z0
    z0list.append(z0)
    
    [histy,histx]=np.histogram(Yarray,20,[np.min(Yarray),np.max(Yarray)])
#    print histy, histx
    bins=[]
    count=[]
#    print np.min(Yarray),np.max(Yarray) 
    for i in range(len(histx)-1):
#        print len(histx)
#        print i
#        print histx
#        print bins
        bins.append(histx[i]) 
        
        count.append(histy[i])
    binarray=np.array(bins,float)
    countarray=np.array(count,int)
    nonesim=np.sum(count,axis=0)
    
#    print binarray
#    print countarray
#    print len(binarray)
#    print nonesim 
    p1=plt.plot(binarray,countarray)
    plt.xlabel('y')
    plt.ylabel('Number of Counts')


#print i, "\t", j
#print TotalColumn
#print len(TotalColumn)
TotalColumnarray=np.array(TotalColumn,float)
z0array=np.array(z0list,float)
#print z0array
plt.show()
[histtotaly,histtotalx]=np.histogram(TotalColumnarray,200,[np.min(TotalColumnarray),np.max(TotalColumnarray)])
#print histtotaly,histtotalx
totalbins=[]
totalcounts=[]
#print np.min(TotalColumnarray),np.max(TotalColumnarray)
for i in range(len(histtotalx)-1):
    totalbins.append(histtotalx[i])
    totalcounts.append(histtotaly[i])
totalbinarray=np.array(totalbins,float)
totalcountarray=np.array(totalcounts,int)
p2=plt.plot(totalbinarray,totalcountarray)
plt.show()
A,betaF,negbetaF=WHAM(totalcountarray,totalbinarray,z0array,nonesim,J, 10**-6,25000)
p3=plt.plot(totalbinarray[:120],negbetaF[:120])
plt.show()
p4=plt.plot(totalbinarray[:120],betaF[:120])
plt.show()